library(blocking)
library(reclin2)

df_example <- data.frame(txt = c(
  "jankowalski",
  "kowalskijan",
  "kowalskimjan",
  "kowaljan",
  "montypython",
  "pythonmonty",
  "cyrkmontypython",
  "monty"
))
df_base <- data.frame(txt = c("montypython", "kowalskijan", "somethingcompletelydifferent"))



# testing matrix input ----------------------------------------------------

mat_x <- structure(c(0, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1,
                     0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0,
                     1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 1, 0,
                     0, 2, 0, 0, 1, 0, 1),
                   dim = c(3L, 22L),
                   dimnames = list(c(`1` = "1", `2` = "2", `3` = "3"),
                                   c("al", "an", "er", "he", "ho", "ij", "ja", "ki", "ko",
                                     "ls", "mo", "nt", "ot", "ow", "py", "sk", "ty",
                                     "wa", "yp", "yt", "on", "th")))

mat_y <- structure(c(0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0,
                     0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0,
                     0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                     0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0,
                     0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 1, 1, 0, 0,
                     0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 1,
                     1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1,
                     0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1,
                     0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0,
                     0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1,
                     1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2, 1),
                   dim = c(8L, 28L),
                   dimnames = list(c(`1` = "1", `2` = "2", `3` = "3", `4` = "4",
                                     `5` = "5", `6` = "6", `7` = "7", `8` = "8"),
                                   c("cy", "ij", "im", "km", "lj", "mj", "nk", "nm", "rk", "yr", "yp", "ho", "ki", "ls",
                                     "py", "sk", "th", "yt", "al", "an", "ja", "ko", "mo", "nt", "ow",
                                     "ty", "wa", "on")))
